#include <ESP8266WiFi.h>
#include <LittleFS.h>

#include <ESP8266WebServer.h>
ESP8266WebServer server(80);


IPAddress local_IP(192,168,4,2);
IPAddress gateway(192,168,4,1);
IPAddress subnet(255,255,252,0);
int WiFi_OK;
int WiFi_Mode = 1;
String getContentType(String filename)
{ // convert the file extension to the MIME type
   if (filename.endsWith(".html")) return "text/html";
   else if (filename.endsWith(".css")) return "text/css";
   else if (filename.endsWith(".js")) return "application/javascript";
   else if (filename.endsWith(".ico")) return "image/x-icon";
   return "text/plain";
}

void ListDirLittleFS()
{
String str = "";
 Dir dir = LittleFS.openDir("/");
 while (dir.next()) {
    str += dir.fileName();
    str += " / ";
    str += dir.fileSize();
    str += "\r\n";
 }
 Serial.print(str);
}

bool handleFileRead(String path)
{ // send the right file to the client (if it exists)
 //Serial.println("handleFileRead: " + path);
 if (path.endsWith("/")) path += "index.html";         // If a folder is requested, send the index file
  String contentType = getContentType(path);            // Get the MIME type
  if (LittleFS.exists(path)) {                            // If the file exists
    File file = LittleFS.open(path, "r");                 // Open it
    size_t sent = server.streamFile(file, contentType); // And send it to the client
    file.close();                                       // Then close the file again
    return true;
 }
  Serial.print("File :"); Serial.print(path);Serial.println(" Not Found");
  return false;
}

int EtatLED;
String Page;

// Décrire cette fonction
void FonctionURLNotFound() {
  Page = String("La page ") + String(server.uri()) + String(" n\'existe pas");
  Serial.println(Page);
}


// Décrire cette fonction
void Marche() {
  EtatLED = 1;
  digitalWrite(2, LOW);
  handleFileRead( "Marche.html" );
}


// Décrire cette fonction
void PageDefaut() {
  if (EtatLED) {
    Marche();

  } else {
    Arret();

  }
}


// Décrire cette fonction
void Arret() {
  EtatLED = 0;
  digitalWrite(2, HIGH);
  handleFileRead( "Arret.html" );
}



void setup() {
  Serial.begin(115200);
  pinMode(2, OUTPUT);
  WiFi_OK = WiFi.softAPConfig(local_IP, gateway, subnet);
WiFi_OK &= WiFi.softAP("ESP8266_SSID");

  if(!LittleFS.begin()) {
  Serial.println("An Error has occurred while mounting LittleFS");
  return;
  }
  Serial.println("LittleFS Ready");

    EtatLED = 0;
  Page = "";
  Serial.println("Démarrage");
  digitalWrite(2, HIGH);
  ListDirLittleFS();
  server.on("/", PageDefaut);
  server.on("/marche", Marche);
  server.on("/arret", Arret);
  server.onNotFound(FonctionURLNotFound);
  server.begin();

}

void loop() {
    server.handleClient();

}
